import java.awt.*;
/**
  *
  * Diese Klasse bildet die Basisklasse aller Generationen zu verschiedenen Problemen, die mit genetischen Algorithmen gelst werden sollen.
  *
  * @version 09.12.2009
  * @author Daniel Garmann
  */

public abstract class Generation {

  // Anfang Attribute
  private Individuum[] individuen;
  private int groesse;
  private double mutationsrate;
  private double kreuzungsrate;
  // Ende Attribute
  
  public Generation(int groesse, int laenge) {
    this.groesse = groesse;
    individuen = new Individuum[groesse];
    for (int i = 0; i < groesse; i++) {
      individuen[i] = new Individuum(laenge);
    }
  }

  // Anfang Methoden
  public void generationenwechsel() {

    // hier kommen Ihre Programmzeilen hin

  }
  
  public Individuum selektion() {

    // hier kommen Ihre Programmzeilen hin
    return null;

  }
  
  public Individuum mutation(Individuum individuum) {

    // hier kommen Ihre Programmzeilen hin
    return null;

  }
  
  public Individuum kreuzung(Individuum vater, Individuum mutter) {

    // hier kommen Ihre Programmzeilen hin
    return null;

  }

  public Individuum bestesIndividuum() {
    int bestesIndividuumIndex = 0;
    for (int i = 1; i < groesse; i++) {
      if (fitness(individuen[i]) > fitness(individuen[bestesIndividuumIndex])) {
        bestesIndividuumIndex = i;
      }
    }
    return individuen[bestesIndividuumIndex];
  }

  public double getMutationsrate() {
    return mutationsrate;
  }

  public void setMutationsrate(double mutationsrate) {
    this.mutationsrate = mutationsrate;
  }

  public double getKreuzungsrate() {
    return kreuzungsrate;
  }

  public void setKreuzungsrate(double kreuzungsrate) {
    this.kreuzungsrate = kreuzungsrate;
  }
  
  public Individuum getIndividuum(int nr) {
    return individuen[nr];
  }

  public int getGroesse() {
    return groesse;
  }
  
  public void paint(Graphics g) {
    g.clearRect(0,0,200,200);

    Individuum bestesIndividuum = this.bestesIndividuum();
    
    double scaley = 190.0 / (fitness(bestesIndividuum)+1);
    double scalex = 200.0 / groesse;
    
    for (int i = 0; i < groesse; i++) {
      g.fillRect((int)(i*scalex+scalex/2-2),200-(int)(fitness(this.getIndividuum(i))*scaley+5),4,4);
    }
    g.drawString("max. Fitness= "+fitness(bestesIndividuum),0,10);

    g.drawRect(0,0,199,199);
  }
  
  public abstract int fitness(Individuum individuum);

  // Ende Methoden
}
