/**
  *
  * Zu Speicherung der Information eines Individuums (Gencode) wird diese Klasse von Generation verwendet.
  *
  * @version 09.12.2009
  * @author Daniel Garmann
  */

public class Individuum {

  // Anfang Attribute
  private int laenge;
  private int[] gencode;
  // Ende Attribute

  public Individuum(int laenge) {
    this.laenge = laenge;
    gencode = new int[laenge];
    for (int i = 0; i < laenge; i++) {
      gencode[i] = (int)(Math.random()*2);
    }
  }
  
  public Individuum(Individuum individuum) {
    this.laenge = individuum.getLaenge();
    this.gencode = new int[laenge];
    for (int i = 0; i < laenge; i++) {
      this.gencode[i] = individuum.getGencode(i);
    }
  }

  // Anfang Methoden
  public int getLaenge() {
    return laenge;
  }

  public void setLaenge(int laenge) {
    this.laenge = laenge;
  }
  
  public int getGencode(int stelle) {
    return gencode[stelle];
  }

  public void setGencode(int stelle, int wert) {
    gencode[stelle] = wert;
  }
  
  public String toString() {
    String result = "{";
    for (int i = 0; i < laenge; i++) {
      result = result + gencode[i];
      if (i < laenge) result = result + ",";
    }
    result = result + "}";
    return result;
  }

  // Ende Methoden
}
